/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * Reuse
 */

public class Reuse {
  @JsonProperty("badges")
  private List<Badge> badges = null;

  @JsonProperty("created_at")
  private LocalDateTime createdAt = null;

  @JsonProperty("datasets")
  private List<Dataset> datasets = null;

  @JsonProperty("deleted")
  private LocalDateTime deleted = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("featured")
  private Boolean featured = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("image")
  private String image = null;

  @JsonProperty("image_thumbnail")
  private String imageThumbnail = null;

  @JsonProperty("last_modified")
  private LocalDateTime lastModified = null;

  @JsonProperty("metrics")
  private Object metrics = null;

  @JsonProperty("organization")
  private Object organization = null;

  @JsonProperty("owner")
  private Object owner = null;

  @JsonProperty("page")
  private String page = null;

  @JsonProperty("private")
  private Boolean _private = null;

  @JsonProperty("slug")
  private String slug = null;

  @JsonProperty("tags")
  private List<String> tags = null;

  @JsonProperty("title")
  private String title = null;

  /**
   * The reuse type
   */
  public enum TypeEnum {
    API("api"),

    APPLICATION("application"),

    IDEA("idea"),

    NEWS_ARTICLE("news_article"),

    PAPER("paper"),

    POST("post"),

    VISUALIZATION("visualization"),

    HARDWARE("hardware");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String text) {
      for (TypeEnum b : TypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("type")
  private TypeEnum type = null;

  @JsonProperty("uri")
  private String uri = null;

  @JsonProperty("url")
  private String url = null;

   /**
   * The reuse badges
   * @return badges
  **/
  @ApiModelProperty(value = "The reuse badges")
  public List<Badge> getBadges() {
    return badges;
  }

   /**
   * The reuse creation date
   * @return createdAt
  **/
  @ApiModelProperty(value = "The reuse creation date")
  public LocalDateTime getCreatedAt() {
    return createdAt;
  }

  public Reuse datasets(List<Dataset> datasets) {
    this.datasets = datasets;
    return this;
  }

  public Reuse addDatasetsItem(Dataset datasetsItem) {
    if (this.datasets == null) {
      this.datasets = new ArrayList<Dataset>();
    }
    this.datasets.add(datasetsItem);
    return this;
  }

   /**
   * The reused datasets
   * @return datasets
  **/
  @ApiModelProperty(value = "The reused datasets")
  public List<Dataset> getDatasets() {
    return datasets;
  }

  public void setDatasets(List<Dataset> datasets) {
    this.datasets = datasets;
  }

   /**
   * The organization identifier
   * @return deleted
  **/
  @ApiModelProperty(value = "The organization identifier")
  public LocalDateTime getDeleted() {
    return deleted;
  }

  public Reuse description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The reuse description in Markdown
   * @return description
  **/
  @ApiModelProperty(required = true, value = "The reuse description in Markdown")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

   /**
   * Is the reuse featured
   * @return featured
  **/
  @ApiModelProperty(value = "Is the reuse featured")
  public Boolean isFeatured() {
    return featured;
  }

   /**
   * The reuse identifier
   * @return id
  **/
  @ApiModelProperty(value = "The reuse identifier")
  public String getId() {
    return id;
  }

  public Reuse image(String image) {
    this.image = image;
    return this;
  }

   /**
   * The reuse thumbnail thumbnail (cropped) URL
   * @return image
  **/
  @ApiModelProperty(value = "The reuse thumbnail thumbnail (cropped) URL")
  public String getImage() {
    return image;
  }

  public void setImage(String image) {
    this.image = image;
  }

  public Reuse imageThumbnail(String imageThumbnail) {
    this.imageThumbnail = imageThumbnail;
    return this;
  }

   /**
   * The reuse thumbnail thumbnail URL. This is the square (100x100) and cropped version.
   * @return imageThumbnail
  **/
  @ApiModelProperty(value = "The reuse thumbnail thumbnail URL. This is the square (100x100) and cropped version.")
  public String getImageThumbnail() {
    return imageThumbnail;
  }

  public void setImageThumbnail(String imageThumbnail) {
    this.imageThumbnail = imageThumbnail;
  }

   /**
   * The reuse last modification date
   * @return lastModified
  **/
  @ApiModelProperty(value = "The reuse last modification date")
  public LocalDateTime getLastModified() {
    return lastModified;
  }

   /**
   * The reuse metrics
   * @return metrics
  **/
  @ApiModelProperty(value = "The reuse metrics")
  public Object getMetrics() {
    return metrics;
  }

  public Reuse organization(Object organization) {
    this.organization = organization;
    return this;
  }

   /**
   * The publishing organization
   * @return organization
  **/
  @ApiModelProperty(value = "The publishing organization")
  public Object getOrganization() {
    return organization;
  }

  public void setOrganization(Object organization) {
    this.organization = organization;
  }

  public Reuse owner(Object owner) {
    this.owner = owner;
    return this;
  }

   /**
   * The owner user
   * @return owner
  **/
  @ApiModelProperty(value = "The owner user")
  public Object getOwner() {
    return owner;
  }

  public void setOwner(Object owner) {
    this.owner = owner;
  }

   /**
   * The reuse page URL
   * @return page
  **/
  @ApiModelProperty(value = "The reuse page URL")
  public String getPage() {
    return page;
  }

  public Reuse _private(Boolean _private) {
    this._private = _private;
    return this;
  }

   /**
   * Is the reuse private to the owner or the organization
   * @return _private
  **/
  @ApiModelProperty(value = "Is the reuse private to the owner or the organization")
  public Boolean isPrivate() {
    return _private;
  }

  public void setPrivate(Boolean _private) {
    this._private = _private;
  }

   /**
   * The reuse permalink string
   * @return slug
  **/
  @ApiModelProperty(value = "The reuse permalink string")
  public String getSlug() {
    return slug;
  }

  public Reuse tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public Reuse addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Some keywords to help in search
   * @return tags
  **/
  @ApiModelProperty(value = "Some keywords to help in search")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public Reuse title(String title) {
    this.title = title;
    return this;
  }

   /**
   * The reuse title
   * @return title
  **/
  @ApiModelProperty(required = true, value = "The reuse title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public Reuse type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * The reuse type
   * @return type
  **/
  @ApiModelProperty(example = "api", required = true, value = "The reuse type")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

   /**
   * The reuse API URI
   * @return uri
  **/
  @ApiModelProperty(value = "The reuse API URI")
  public String getUri() {
    return uri;
  }

  public Reuse url(String url) {
    this.url = url;
    return this;
  }

   /**
   * The reuse remote URL (website)
   * @return url
  **/
  @ApiModelProperty(required = true, value = "The reuse remote URL (website)")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Reuse reuse = (Reuse) o;
    return Objects.equals(this.badges, reuse.badges) &&
        Objects.equals(this.createdAt, reuse.createdAt) &&
        Objects.equals(this.datasets, reuse.datasets) &&
        Objects.equals(this.deleted, reuse.deleted) &&
        Objects.equals(this.description, reuse.description) &&
        Objects.equals(this.featured, reuse.featured) &&
        Objects.equals(this.id, reuse.id) &&
        Objects.equals(this.image, reuse.image) &&
        Objects.equals(this.imageThumbnail, reuse.imageThumbnail) &&
        Objects.equals(this.lastModified, reuse.lastModified) &&
        Objects.equals(this.metrics, reuse.metrics) &&
        Objects.equals(this.organization, reuse.organization) &&
        Objects.equals(this.owner, reuse.owner) &&
        Objects.equals(this.page, reuse.page) &&
        Objects.equals(this._private, reuse._private) &&
        Objects.equals(this.slug, reuse.slug) &&
        Objects.equals(this.tags, reuse.tags) &&
        Objects.equals(this.title, reuse.title) &&
        Objects.equals(this.type, reuse.type) &&
        Objects.equals(this.uri, reuse.uri) &&
        Objects.equals(this.url, reuse.url);
  }

  @Override
  public int hashCode() {
    return Objects.hash(badges, createdAt, datasets, deleted, description, featured, id, image, imageThumbnail, lastModified, metrics, organization, owner, page, _private, slug, tags, title, type, uri, url);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Reuse {\n");

    sb.append("    badges: ").append(toIndentedString(badges)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    datasets: ").append(toIndentedString(datasets)).append("\n");
    sb.append("    deleted: ").append(toIndentedString(deleted)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    featured: ").append(toIndentedString(featured)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    image: ").append(toIndentedString(image)).append("\n");
    sb.append("    imageThumbnail: ").append(toIndentedString(imageThumbnail)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("    metrics: ").append(toIndentedString(metrics)).append("\n");
    sb.append("    organization: ").append(toIndentedString(organization)).append("\n");
    sb.append("    owner: ").append(toIndentedString(owner)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    _private: ").append(toIndentedString(_private)).append("\n");
    sb.append("    slug: ").append(toIndentedString(slug)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    uri: ").append(toIndentedString(uri)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

